/**
 * @file InterruptSingleChannel.ino
 * @brief Read in RC, then write value to servo.
 */
#include <Servo.h>
#include "receiver.h"

#define STEER_CENTER 129

// 1/RC_STEER_DAMPER times RC_VALUE (0-180)
#define RC_STEER_DAMPER 4
Servo steering_servo;
int pos = 0;

// Note the following mapping is used between pins and interrupt numbers:
//Board	int.0	int.1	int.2	int.3	int.4	int.5
//Uno, Ethernet	2	3
//Mega2560	2	3	21	20	19	18
//Leonardo	3	2	0	1	7
//Due	(see below)

void setup()
{
  receiver_init();
  steering_servo.attach(9);  // attaches the servo on pin 9 to the servo object
  Serial.begin(9600);
}

void loop()
{
  static int input = 128;
  if(rc_available[THR_INDEX]) {
    input = receiver_get_angle(THR_INDEX);
  }

  //steering_servo.write(133+(input-128)/20);
  // I decided 133 is center
  // Note that 4 is a damping factor.
  // 43
  int out = (input/4)+(90*3/4)+39;
  if(out < 105 || out > 160) {
    Serial.println("FAKFAKFAK SERVO OUT OF RANGE");
    Serial.println(out);
    out = 129;
  }
  Serial.println(out);
  steering_servo.write(out);
}
